	include	"tios.h"
	include	"flib.h"
	include	"mzlib.h"
	xdef	_main
	xdef	_comment

_main:
	bra clear
start:
	jsr flib::idle_loop
	cmpi.w #113,d0
	beq exit
	cmpi.w #263,d0
	beq clear
	cmpi.w #337,d0
	beq left
	cmpi.w #340,d0
	beq right
	cmpi.w #338,d0
	beq up
	cmpi.w #344,d0
	beq down
	cmpi.w #4434,d0
	beq u10
	cmpi.w #4440,d0
	beq d10
	cmpi.w #43,d0
	beq plus
	cmpi.w #45,d0
	beq minus
	cmpi.w #259,d0
	beq sin
	cmpi.w #260,d0
	beq cos
	cmpi.w #4355,d0
	beq s10
	cmpi.w #4356,d0
	beq c10
	bra start
clear:
	clr.l d5
	clr.l d4
	clr.l d3
	clr.l d2
	clr.l d1
	lea _comment(pc),a2
	movem.l d1-d5,-(a2)
	movem.l d1-d5,-(a2)
	move.b #1,3(a2)
	move.b #1,11(a2)
	move.b #1,19(a2)
	move.b #1,27(a2)
	move.b #1,35(a2)
	bra nokey
minus:
	subi.w #2,2(a2,d5.w)
plus:
	addi.w #1,2(a2,d5.w)
	beq plus
	bra nokey
sin:
	subi.l #$142,4(a2,d5.w)
cos:
	addi.l #$a1,4(a2,d5.w)
	bra nokey
s10:
	subi.l #$a10,4(a2,d5.w)
c10:
	addi.l #$508,4(a2,d5.w)
	bra nokey
right:
	cmpi.w #32,d5
	beq nokey
	addi.w #16,d5
left:
	tst.w d5
	beq nokey
	subi.w #8,d5
	bra nokey
d10:
	subi.w #16,0(a2,d5.w)
u10:
	addi.w #9,0(a2,d5.w)
down:
	subi.w #2,0(a2,d5.w)
up:
	addi.w #1,0(a2,d5.w)
nokey:
	jsr flib::zap_screen
	move.l #$c40020,d3
	move.w #-10,d6
l1:
	bsr scale
	subi.l #$300008,d3
	bge l1
	move.l #$c40020,d3
	addi.w #10,d6
	ble l1

	move.w d5,d6
	mulu #6,d6
	addi.w #10,d6
	move.w d6,-(a7)
	move.w #$63,-(a7)
	move.l #1,-(a7)
	move.w 2(a2,d5.w),d6
	move.l d6,-(a7)
	jsr mzlib::put_hex
	lea 12(a7),a7

	clr.w d3
	move.l #-$3244,d2
loop:
	move.w #40,d4
	clr.l d1
getnum:
	move.l d2,d0
	muls -6(a2,d4.w),d0
	add.l -4(a2,d4.w),d0
	bsr sine
	muls -8(a2,d4.w),d0
	add.l d0,d1
	subi.w #8,d4
	bne getnum
	lsr.l #5,d1
;	lsr.l #8,d1
	subi.w #7000,d1
	neg.w d1
	blt clear
	lsr.w #7,d1
	mulu #30,d1
	move.w #$4440,a0
	add.l d1,a0
	move.w d3,d0
	lsr.w #3,d0
	add.w d0,a0
	cmpa.l #$5300,a0
	bgt clear
	move.w d3,d0
	andi.w #7,d0
	eori.w #7,d0
	bchg.b d0,(a0)
	addi.l #107,d2
	addi.w #1,d3
	cmpi.w #240,d3
	bne loop 
	bra start
exit:
	rts

;*********************************************************

sine:
	movem.l d1-d3,-(a7)
	tst.l d0
	bge pos1
	neg.l d0
	bset.l #31,d3
pos1:
	divs #$3244,d0
	btst.b #0,d0
	beq pos2
	bchg.l #31,d3
pos2:
	lsr.l #8,d0
	lsr.l #8,d0
	subi.w #$1922,d0
	ble pos3
	neg.w d0
pos3:
	addi.w #$1922,d0
	move.w d0,d1
	move.w d0,d2
	move.w d0,d3
	mulu d1,d1
	lsr.l #6,d1
	lsr.l #6,d1
	mulu d1,d2
	divu #24576,d2
	sub.w d2,d3
	mulu d1,d2
	divu #20480,d2
	lsr.w #2,d2
	add.w d2,d3
	mulu d1,d2
	divu #21504,d2
	lsr.w #3,d2
	sub.w d2,d3
	move.w d3,d0
	btst.l #31,d3
	beq neg
	neg.w d0
neg:
	movem.l (a7)+,d1-d3
	rts

;***********************************************

scale:
	move.l d3,d4
	move.w d6,d4
	add.w #$74,d4
	bsr m
	add.w #8,d4
	bsr d
	sub.w #4,d4
	bsr m
	add.l #$140000,d4
	bsr d
	add.w #2,d4
	bsr m
	sub.w #4,d4
	bsr d
	add.w #2,d4
	bsr m
	add.l #$140000,d4
	bsr d
	sub.w #4,d4
	bsr m
	add.w #8,d4
	bsr d
	subi.l #$140001,d4
;
	tst.w d6
	beq two
	move.w 0(a2,d3.w),d2
	muls #2,d2
	divs #4,d2
	bra one
two:
	move.l 4(a2,d3.w),d2
	divs #$142,d2
one:
	swap d4
	add.w d2,d4
	swap d4
;
	bsr m
	sub.w #6,d4
	bsr d
	add.l #$10001,d4
	bsr d
	add.w #4,d4
	bsr d
	sub.l #$20000,d4
	bsr d
	sub.w #4,d4
	bsr d
	rts

m:
	move.l d4,-(a7)
	jsr tios::MoveTo
	lea 4(a7),a7
	rts
d:
	move.l d4,-(a7)
	jsr tios::DrawTo
	lea 4(a7),a7
	rts

vars:	ds.w 4	;amp.w,hz.w,phase.w
	ds.w 4
	ds.w 4
	ds.w 4
	ds.w 4

_comment:	dc.b	"Wave Motion by M Zeppenfeld",0
  end